<!DOCTYPE html>
<html>
  <head>
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <script>
      "use strict";
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      const gBASE_URL1 = "http://localhost:8080/users/v1";
      const gBASE_URL2 = "http://localhost:8080/users/v2";
      var gListUserObjects = [];

      /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
      $(document).ready(function () {
        onPageLoading();
        //add event change for select car
        $("#btn-login").on("click", function (event) {
          event.preventDefault();
          onBtnLoginSubmit();
        });
        $("#sign-up").on("click", function (event) {
          event.preventDefault();
          onSignUp();
        });
      });

      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      //hàm xử lý sự kiện submit form
      function onBtnLoginSubmit() {
        //b1: thu thập dữ liệu
        var vLoginObj = {
          username: "",
          password: "",
          isRemember: false,
        };
        getLoginData(vLoginObj);

        //b2: kiểm tra dữ liệu
        var vValid = validateLoginData(vLoginObj);
        if (vValid) {
          //b3: hiển thị console
          login(vLoginObj);
          callApiLogin(vLoginObj);
        }
      }

      //hàm xử lý sign up
      function onSignUp() {
        const vDETAIL_FORM_URL = "register.html";
        var vUrlToOpenPage = vDETAIL_FORM_URL;
        window.location.href = vUrlToOpenPage;
      }

      function onPageLoading() {
        callApiToGetListData();
      }

      //hàm call API to get all article
      function callApiToGetListData() {
        $.ajax({
          url: gBASE_URL2 + "/all",
          type: "GET",
          dataType: "json",
          success: function (responseObject) {
            gListUserObjects = responseObject;
            console.log(gListUserObjects);
          },
          error: function (error) {
            console.assert(error.responseText);
          },
        });
      }

      function callApiLogin(paramObjData) {
        $.ajax({
          url: gBASE_URL1 + "/login",
          type: "POST",
          contentType: "application/json;charset=UTF-8",
          data: JSON.stringify(paramObjData),
          success: function (paramRes) {
            // handleCreateSuccess();
          },
          error: function (paramErr) {
            console.log(paramErr.responseText);
          },
        });
      }

      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      function getLoginData(paramLoginObj) {
        paramLoginObj.username = $("#inp-login-username").val().trim();
        paramLoginObj.password = $("#pwd-login-password").val().trim();
        paramLoginObj.isRemember = $("#ckb-remember-username").is(":checked");
      }

      function validateLoginData(paramLoginObj) {
        if (paramLoginObj.username == "") {
          alert("You forget fill username!");
          $("#inp-login-username").focus();
          return false;
        }
        if (paramLoginObj.password == "") {
          alert("You forget fill password!");
          $("#inp-login-password").focus();
          return false;
        }
        return true;
      }

      //hàm thực hiện khi click nút login
      function login(paramLoginObj) {
        console.log(paramLoginObj);
      }
    </script>
  </head>

  <body>
    <div class="container">
      <form>
        <div class="row d-flex align-items-center min-vh-100">
          <div class="col-sm-4 text-center mx-auto my-0 jumbotron">
            <div class="mb-5">
              <h3 class="text-center">Login to your account</h3>
            </div>

            <div>
              <div class="form-group">
                <input
                  type="text"
                  name="username"
                  placeholder="Username"
                  id="inp-login-username"
                  class="form-control"
                  value=""
                  autocomplete="username"
                  required
                />
              </div>
              <div class="form-group">
                <input
                  name="password"
                  type="password"
                  id="pwd-login-password"
                  placeholder="Password"
                  class="form-control"
                  value=""
                  autocomplete="inp-current-password"
                  required
                />
              </div>
              <div class="form-group">
                <input
                  type="checkbox"
                  name="rememberusername"
                  id="ckb-remember-username"
                  class="form-check-input"
                />
                <label class="form-check-label" for="rememberusername"
                  >Reemember username</label
                >

                <a class="float-right" href="#">Lost password?</a>
              </div>
              <div class="form-group">
                <button class="btn btn-log btn-block btn-info" id="btn-login">
                  Log in
                </button>
              </div>
            </div>

            <div class="text-left" id="sign-up">
              Or <a href="#">Sign-up</a> for having an account
            </div>
          </div>
        </div>
      </form>
    </div>
  </body>
</html>
